package com.loafle.overflow.crawler.wmi;

import com.loafle.overflow.crawler.config.Config;
import com.loafle.overflow.crawler.config.Item;
import com.loafle.overflow.crawler.result.OFResultSet;

import java.util.*;



/**
 * Created by root on 17. 4. 12.
 */
public class WMICrawlerLinux extends WMICrawlerOS {

    private final String DELIMITER = "||";
    private final String DELIMITER_SPLIT = "\\|\\|";

    public OFResultSet processWMI(Config config, Item item) throws Exception {

        List<String> argList = createCommand(config, item);

        String result = execute(argList.toArray(new String[argList.size()]));

        OFResultSet ofResultSet = parseResult(result, item);

        return ofResultSet;
    }

    public List<String> createCommand(Config config, Item item) throws Exception {

        String id = (String)config.getTarget().getAuth().get("id");
        String pw = (String)config.getTarget().getAuth().get("pw");
        String nameSpace = (String)item.getQueryInfo().getExtend().get("nameSpace");
        String ip = config.getTarget().getConnection().getIp();
        String query = item.getQueryInfo().getQuery();


        List<String> argList = new ArrayList<String>();

        argList.add("/home/snoop/temp/wmic");
        argList.add("-U");
        argList.add(id + "%" + pw);
        argList.add("//" + ip);
        argList.add(query);
        argList.add("--namespace=" + nameSpace);
        argList.add("--delimiter=" + DELIMITER);

        return argList;
    }

    public String execute(String... args) throws Exception {
        System.out.println("");
        ProcessBuilder builder = new ProcessBuilder(args);
        Process process = builder.start();

        byte[] msg = new byte[1024];

        StringBuffer buf = new StringBuffer();

        while(process.getInputStream().read(msg) > 0) {
            buf.append(new String(msg));
            Arrays.fill(msg, (byte)0);
        }

        return buf.toString();
    }

    public OFResultSet parseResult(String result, Item item) throws Exception {

        if(result == null || result.length() <= 0) {
            return null;
        }

        result = result.trim();

        String errStr = checkError(result);
        if(errStr.length() > 0) {
//            map.put("ERROR", errStr);
            return null;
        }


        String[] lines = result.split("\\n");
        String line = "";

        OFResultSet ofResultSet = OFResultSet.newInstance(item);
        Map<String, Integer> metaMap = ofResultSet.getMeta();

        List<String> columns = null;
        Map<String, String>  tempMap = new HashMap<String, String>();
        List<String> row = null;
        for (int indexI = 0 ; indexI < lines.length; ++indexI) {
            tempMap.clear();;

            line = lines[indexI].trim();
            if (line.length() <= 0) continue;
            if(indexI == 0) {
                int idx = line.indexOf("CLASS:");
                if (idx >= 0 ) {
                    continue;
                }
            }

            line = line.trim();

            if (columns == null) {
                String[] datas = line.split(DELIMITER_SPLIT);
                columns = Arrays.asList(datas);
                continue;
            }

            row = new ArrayList<>(Arrays.asList(new String[metaMap.size()]));

            String[] datas = line.split(DELIMITER_SPLIT);

            for(int indexJ = 0; indexJ < columns.size(); ++indexJ) {
                tempMap.put(columns.get(indexJ), datas[indexJ]);
            }

            for (Map.Entry<String, Integer> info : metaMap.entrySet()) {
                row.set(info.getValue().intValue(), tempMap.get(info.getKey()));
            }


            ofResultSet.addRow(row);

        }

        return ofResultSet;
    }

    public String checkError(String result) {
        int errIdx = result.indexOf("ERROR:");
        String retErrStr = "";
        if(errIdx >= 0) {

            int enterIdx = result.indexOf("\\n", errIdx);
            if(enterIdx < 0) enterIdx = result.length();
            String errStr = result.substring(errIdx + "ERROR:".length(), enterIdx);


//            Map<String,String> map = new HashMap<>();

//            map.put("ERROR", errStr);
//            resultMapList.add(map);
//            return resultMapList;
            retErrStr = errStr;
        }
        return retErrStr;
    }
}
