package com.loafle.overflow.crawler.wmi;

import com.jacob.activeX.ActiveXComponent;
import com.loafle.overflow.crawler.config.Config;
import com.loafle.overflow.crawler.config.Item;
import com.loafle.overflow.crawler.result.OFResultSet;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by root on 17. 4. 12.
 */
public abstract class WMICrawlerOS {

    private static WMICrawlerOS wmiCrawlerOS = null;

    public static WMICrawlerOS getInstance() {

        if(WMICrawlerOS.wmiCrawlerOS == null) {

            String os = System.getProperty("os.name").toLowerCase();

            if(os.indexOf("linux") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerLinux();
            } else if(os.indexOf("") >= 0) {
                WMICrawlerOS.wmiCrawlerOS = new WMICrawlerWindows();
            }

        }

        return WMICrawlerOS.wmiCrawlerOS;
    }

    public Object process(Config config)  throws Exception {

        List<OFResultSet> retlist = new ArrayList<>();
        OFResultSet ofResultSet = null;
        for(int cIndexI = 0 ; cIndexI < config.getItems().size() ; ++cIndexI) {

            ofResultSet = processWMI(config, config.getItems().get(cIndexI));
            retlist.add(ofResultSet);
        }


        return retlist;
    }

    public abstract OFResultSet processWMI(Config config, Item item) throws Exception ;
}
