package com.loafle.overflow.crawler.wmi;

import com.jacob.activeX.ActiveXComponent;
import com.jacob.com.Dispatch;
import com.jacob.com.EnumVariant;
import com.jacob.com.Variant;
import com.loafle.overflow.crawler.config.Config;
import com.loafle.overflow.crawler.config.Item;
import com.loafle.overflow.crawler.config.Query;
import com.loafle.overflow.crawler.result.OFResultSet;
import com.loafle.overflow.crawler.result.OFResultSetCol;

import java.util.*;

/**
 * Created by snoop on 2017-04-11.
 */
public class WMICrawlerWindows extends WMICrawlerOS {

    public OFResultSet processWMI(Config config, Item item) throws Exception {

        String query = "";
        ActiveXComponent wmiconnect = null;
        OFResultSet ofResultSet = null;


        query = item.getQueryInfo().getQuery();
        wmiconnect = connectServer(config, item);

        Variant vQuery = new Variant(query);
        Variant vCollection = wmiconnect.invoke("ExecQuery", vQuery);
        wmiconnect.safeRelease();
        vQuery.safeRelease();

        Dispatch dConnection = vCollection.toDispatch();
        vCollection.safeRelease();
//            int count = getCount(dConnection);

        EnumVariant enumVariant = new EnumVariant(dConnection);
        dConnection.safeRelease();

        ofResultSet = getResultSet(enumVariant, item);
        enumVariant.safeRelease();
        return ofResultSet;
    }

    protected OFResultSet getResultSet(EnumVariant enumVariant, Item citem) {

        OFResultSet ofResultSet = OFResultSet.newInstance(citem);

        Variant vItem = null;
        Dispatch item = null;

        Variant vValue = null;
        String value = null;

        List<String> row = null;
        Map<String,Integer> metaMap =  ofResultSet.getMeta();

        while (enumVariant.hasMoreElements()) {

            row = new ArrayList<>(Arrays.asList(new String[metaMap.size()]));

            vItem = enumVariant.nextElement();
            item = vItem.toDispatch();

            for (Map.Entry<String, Integer> info : metaMap.entrySet()) {
                vValue = Dispatch.call(item, info.getKey());
                value = vValue.toString();
                vValue.safeRelease();
                row.set(info.getValue().intValue(), value);
            }

            vItem.safeRelease();
            item.safeRelease();

            ofResultSet.addRow(row);
        }


        return ofResultSet;
    }
//
//    protected void getMultiValue(EnumVariant enumVariant, Query cQuery, Item cItem, int idxMetric, Map<String, String> resultMap) {
//
//        Variant vItem = null;
//        Dispatch item = null;
//
//
//        int keyIdx = 0;
//        while (enumVariant.hasMoreElements()) {
//
//            vItem = enumVariant.nextElement();
//            item = vItem.toDispatch();
//
//
//            String name = null;
//            String value = null;
//            Variant vValue = null;
//
//            for(int indexI = 0 ; indexI < cQuery.getKeys().size(); ++indexI) {
//                name = cQuery.getKeys().get(indexI);
//                vValue = Dispatch.call(item, name);
//                value = vValue.toString();
//                String keyStr = convertArrayKey(cItem.getMetrics().get(indexI),keyIdx );
//                resultMap.put(keyStr, value);
//                vValue.safeRelease();
//            }
//
//            vItem.safeRelease();
//            item.safeRelease();
//            ++idxMetric;
//            ++keyIdx;
//        }
//
//    }

    protected String convertArrayKey(String key, int index) {
        int idx = key.indexOf("[");
        String ret = "";

        if(idx <= 0) {
            idx = key.indexOf(".");
            ret += key.substring(0, idx);
            ret += "[";
            ret += String.valueOf(index);
            ret += "]";
            ret += key.substring(idx +1);
        }else {

            ret += key.substring(0, idx +1);
            ret += String.valueOf(index);
            ret += key.substring(idx +1);
        }


        return ret;
    }

//    protected void getSingleValue(EnumVariant enumVariant, Query cQuery, Item cItem, int idxMetric, Map<String, String> resultMap) {
//
//        Variant vItem = null;
//        Dispatch item = null;
//
//        while (enumVariant.hasMoreElements()) {
//
//            vItem = enumVariant.nextElement();
//            item = vItem.toDispatch();
//
//            String name = null;
//            String value = null;
//            Variant vValue = null;
//
//            for(int indexI = 0 ; indexI < cQuery.getKeys().size(); ++indexI) {
//                name = cQuery.getKeys().get(indexI);
//                vValue = Dispatch.call(item, name);
//                value = vValue.toString();
//                resultMap.put(cItem.getMetrics().get(idxMetric++), value);
//                vValue.safeRelease();
//            }
//
//            vItem.safeRelease();
//            item.safeRelease();
//        }
//
//    }

    protected List<String> getColumns(Dispatch item) {

        List<String> columns = new ArrayList<String>();

        Variant propertyesa = Dispatch.call(item, "Properties_");

        Dispatch disProperty = propertyesa.toDispatch();


        Variant newEnum = Dispatch.call(disProperty, "_NewEnum");

        propertyesa.safeRelease();
        disProperty.safeRelease();

        EnumVariant enumv = newEnum.toEnumVariant();

        newEnum.safeRelease();

        Variant vElem = null;
        Dispatch disElem = null;
        Variant vName = null;

        while (enumv.hasMoreElements()) {
            vElem = enumv.nextElement();
            disElem = vElem.toDispatch();

            vName = Dispatch.call(disElem, "Name");
            String vs = vName.toString();

            columns.add(vs);

            disElem.safeRelease();
            vElem.safeRelease();
            vName.safeRelease();
        }

        enumv.safeRelease();
        return columns;
    }


    protected int getCount(Dispatch d) {

        Variant c = Dispatch.call(d, "Count");

        int retInt = Integer.valueOf(c.toString());

        c.safeRelease();

        return retInt;
    }

    protected ActiveXComponent connectServer(Config config, Item item) {

        String id = (String)config.getTarget().getAuth().get("id");
        String pw = (String)config.getTarget().getAuth().get("pw");
        String nameSpace = (String)item.getQueryInfo().getExtend().get("nameSpace");
//        String query = (String)config.get.get("query");

        String ip = config.getTarget().getConnection().getIp();

        ActiveXComponent wmi = null;
        wmi = new ActiveXComponent("WbemScripting.SWbemLocator");

        Variant vIp = new Variant(ip);
        Variant vNs = new Variant(nameSpace);
        Variant vId = new Variant(id);
        Variant vPw = new Variant(pw);

        Variant conRet = wmi.invoke("ConnectServer", vIp, vNs, vId, vPw);

        vIp.safeRelease();
        vNs.safeRelease();
        vId.safeRelease();
        vPw.safeRelease();

        Dispatch disConret = conRet.toDispatch();

        ActiveXComponent wmiconnect = new ActiveXComponent(disConret);
        disConret.safeRelease();

        wmi.safeRelease();
        conRet.safeRelease();

        return wmiconnect;

    }

}
